#if !defined(AFX_PLAYER_T_H__C69E3341_A2A0_11D3_8551_D1350833310F__INCLUDED_)
#define AFX_PLAYER_T_H__C69E3341_A2A0_11D3_8551_D1350833310F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class player_t  
{
public:
	// functions
	void			init();
	void			add_ping(int ping);
	void			set_name (char* in_name);
	void			set_htmlnames (char* in_name);
	char*			get_name();
	char*			get_htmlname(bool no_funnames);
	int				get_frags();
	double			get_skill();
	double			get_eff();
	double			get_ratio();
	unsigned int	get_kills(int weapon);
	unsigned int	get_teamkills(int weapon);
	unsigned int	get_killed(int weapon);
	unsigned int	get_suicides(int weapon);
	unsigned int	get_kills();
	unsigned int	get_teamkills();
	unsigned int	get_killed();
	unsigned int	get_suicides();
	player_t		operator= (player_t &other);
	player_t*		build_next();
	player_t();
	virtual ~player_t();
	// variables
	bool			listed;						// inited
	player_t*		next;
	int				botskill;					// inited & copied
	int				team;						// inited & copied
	char			htmlname_fun[MAX_FUN_LEN];		// inited & copied
	char			htmlname_nofun[MAX_NOFUN_LEN];	// inited & copied
	char			teams[256];					// inited & copied 
	unsigned int	game_count;					// inited & copied
	unsigned int	ping_count;					// inited & copied
	unsigned int	ping_sum;					// inited & copied
	unsigned short	kills[MAX_WEAPONS];			// inited & copied
	unsigned short	killed[MAX_WEAPONS];		// inited & copied
	unsigned short	suicides[MAX_WEAPONS];		// inited & copied
	unsigned short	teamkills[MAX_WEAPONS];		// inited & copied
	unsigned short	deaths;						// inited & copied
	unsigned int	playtime;					// inited & copied
	unsigned short	mkiol;						// inited & copied
	unsigned short	mkiol_time;					// inited & copied
	// total item pickups
	unsigned int	item_pickups;				// inited & copied
	// items: health & ammo
	unsigned short	item_health_small;			// inited & copied
	unsigned short	item_health_large;			// inited & copied
	unsigned short	item_health_mega;			// inited & copied
	unsigned short	item_health;				// inited & copied
	unsigned short	item_armor_shard;			// inited & copied
	unsigned short	item_armor_combat;			// inited & copied
	unsigned short	item_armor_body;			// inited & copied
	// items: diverse
	unsigned short	item_enviro;				// inited & copied
	unsigned short	item_flight;				// inited & copied
	unsigned short	item_haste;					// inited & copied
	unsigned short	item_invis;					// inited & copied
	unsigned short	item_quad;					// inited & copied
	unsigned short	item_regen;					// inited & copied
	unsigned short	holdable_medkit;			// inited & copied
	unsigned short	holdable_teleporter;		// inited & copied
	unsigned short	team_CTF_blueflag;			// inited & copied
	unsigned short	team_CTF_redflag;			// inited & copied
	// items: ammo
	unsigned short	ammo_bfg;					// inited & copied
	unsigned short	ammo_bullets;				// inited & copied
	unsigned short	ammo_cells;					// inited & copied
	unsigned short	ammo_grenades;				// inited & copied
	unsigned short	ammo_lightning;				// inited & copied
	unsigned short	ammo_rockets;				// inited & copied
	unsigned short	ammo_shells;				// inited & copied
	unsigned short	ammo_slugs;					// inited & copied
	// items: weapons
	unsigned short	weapon_bfg;					// inited & copied
	unsigned short	weapon_grenadelauncher;		// inited & copied
	unsigned short	weapon_lightning;			// inited & copied
	unsigned short	weapon_machinegun;			// inited & copied
	unsigned short	weapon_plasmagun;			// inited & copied
	unsigned short	weapon_railgun;				// inited & copied
	unsigned short	weapon_rocketlauncher;		// inited & copied
	unsigned short	weapon_shotgun;				// inited & copied
private:
	char			name[MAX_NAME_LEN];				// inited & copied
	double			skill;							// inited & copied
	double			eff;							// inited & copied
	double			ratio;							// inited & copied
};

#endif // !defined(AFX_PLAYER_T_H__C69E3341_A2A0_11D3_8551_D1350833310F__INCLUDED_)
